import _regeneratorRuntime from "@babel/runtime/helpers/esm/regeneratorRuntime";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
/*
 * @Author: jiangxin
 * @Date: 2022-03-29 09:29:14
 * @Company: orientsec.com.cn
 * @Description: 分享组件
 */


import React, { useEffect, useCallback, useReducer, useState, useRef } from "react";
import { View } from "@tarojs/components";
import { ShareItem } from "./shareItem";
import { AtActionSheet } from "taro-ui/lib";
import { Share } from "./shareService";
import { ShareError } from "../shareError";
import { useDidHide } from "@tarojs/taro"; // type ClassFunctions<T> = { [K in keyof T]: T[K] extends Function ? T[K] : never };

import "./index.scss";
/**
 * 分享组件
 */

export var SharePanel = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _a, _b, _c;

  var title = props.title,
      desc = props.desc,
      _props$isCancelReject = props.isCancelReject,
      isCancelReject = _props$isCancelReject === void 0 ? false : _props$isCancelReject; // 面板状态

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isOpen = _useState2[0],
      setIsOpen = _useState2[1]; // 点击的平台


  var _useState3 = useState(""),
      _useState4 = _slicedToArray(_useState3, 2),
      selectSupport = _useState4[0],
      setSelectSupport = _useState4[1]; // 关闭分享面板 reject


  var _rejectCurrent = useRef(); // 分享服务 保证服务的稳定


  var _useReducer = useReducer(function () {
    return new Share(props);
  }, undefined, function () {
    return new Share(props);
  }),
      _useReducer2 = _slicedToArray(_useReducer, 1),
      _shareService = _useReducer2[0]; // 更新分享数据


  useEffect(function () {
    var _a;

    title && desc && ((_a = _shareService === null || _shareService === void 0 ? void 0 : _shareService.update) === null || _a === void 0 ? void 0 : _a.call(_shareService, {
      title: title,
      desc: desc
    }));
  }, [title, desc]);
  var asyncResult = useCallback(function (resolve, reject) {
    _rejectCurrent.current = reject;
    selectSupport && isOpen && resolve(selectSupport);
  }, [selectSupport, isOpen]);
  /**
   * 关闭分享面板
   */

  var closeSharePanel = function closeSharePanel() {
    return __awaiter(void 0, void 0, void 0, /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      var _d;

      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setIsOpen(false);
              isCancelReject && ((_d = _rejectCurrent === null || _rejectCurrent === void 0 ? void 0 : _rejectCurrent.current) === null || _d === void 0 ? void 0 : _d.call(_rejectCurrent, new ShareError("关闭分享面板")));

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
  };
  /**
   * 分享点击回调
   */


  var shareHandleCallback = useCallback(function (support) {
    console.log("平台", support);
    setSelectSupport(support);
  }, []);
  useDidHide(function () {
    isOpen && closeSharePanel();
  });
  /**
   * 暴露给外层使用的方法
   */

  React.useImperativeHandle(ref, function () {
    return {
      open: function open() {
        return __awaiter(void 0, void 0, void 0, /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
          return _regeneratorRuntime().wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  setIsOpen(true);
                  return _context2.abrupt("return", new Promise(asyncResult));

                case 2:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));
      } // toShareWeiXinHY: _shareService.current.toShareWeiXinHY,
      // toShareWeiXinPYQ: _shareService.current.toShareWeiXinPYQ,
      // toShareWeiBo: _shareService.current.toShareWeiBo,
      // toShareQQ: _shareService.current.toShareQQ,

    };
  });
  return /*#__PURE__*/React.createElement(AtActionSheet, {
    ref: ref,
    className: 'sharepanel',
    isOpened: isOpen,
    cancelText: "\u53D6\u6D88",
    onClose: closeSharePanel
  }, /*#__PURE__*/React.createElement(View, {
    className: 'sharepanel-content'
  }, (_c = (_a = _shareService === null || _shareService === void 0 ? void 0 : _shareService.getSupportData) === null || _a === void 0 ? void 0 : (_b = _a.call(_shareService)).map) === null || _c === void 0 ? void 0 : _c.call(_b, function (_a) {
    var id = _a.id,
        res = __rest(_a, ["id"]);

    return /*#__PURE__*/React.createElement(ShareItem, Object.assign({
      key: id
    }, res, {
      callback: shareHandleCallback
    }));
  })));
});