import _regeneratorRuntime from "@babel/runtime/helpers/esm/regeneratorRuntime";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var __classPrivateFieldSet = this && this.__classPrivateFieldSet || function (receiver, state, value, kind, f) {
  if (kind === "m") throw new TypeError("Private method is not writable");
  if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
  if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
  return kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value), value;
};

var __classPrivateFieldGet = this && this.__classPrivateFieldGet || function (receiver, state, kind, f) {
  if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
  if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
  return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};

var _Share_instances, _Share_supportsConfig, _Share_title, _Share_desc, _Share_link, _Share_thumbImangeUrl, _Share_support, _Share_isTwiceShare, _Share_getURL, _Share_getShareLink, _Share_nativeShareDirective, _Share_wxShare, _Share_isEqual;
/*
 * @Author: jiangxin
 * @Date: 2022-05-02 20:29:28
 * @Company: orientsec.com.cn
 * @Description: 分享服务
 */


import { onRequest } from "fastman3-dfyjapp-jsbridge";
import { getVersion, isFromWeiXin } from "fastman3-common-helper"; // ((wxshare) => {
//   console.log("wxshare", wxshare);
//   if (wxshare === "true") {
//     const _script = document.createElement("script");
//     _script.src = "https://res.wx.qq.com/open/js/jweixin-1.6.0.js";
//     _script.defer = true;
//     _script.onload = () => {
//       console.log("jweixin脚本加载成功");
//       console.log('wwww',wx);
//     };
//     document.querySelector("body")?.append(_script);
//   }
// })(process.env.WX_SHARE);

export var ChannelEnum;

(function (ChannelEnum) {
  ChannelEnum[ChannelEnum["wxhy"] = 1] = "wxhy";
  ChannelEnum[ChannelEnum["wxpyq"] = 2] = "wxpyq";
  ChannelEnum[ChannelEnum["weibo"] = 3] = "weibo";
  ChannelEnum[ChannelEnum["qq"] = 4] = "qq";
})(ChannelEnum || (ChannelEnum = {}));

export var Share = /*#__PURE__*/function () {
  /**
   * jsskd 实例对象
   */
  //   #WxJsSdkInstance: WxJsSdk;
  function Share(params) {
    var _this = this;

    _classCallCheck(this, Share);

    var _a, _b;

    _Share_instances.add(this);

    _Share_supportsConfig.set(this, {
      wxhy: {
        id: "wxhy",
        channel: ChannelEnum.wxhy,
        icon: require("./icon/wxhy-icon.png"),
        text: "微信好友",
        onHandle: function onHandle() {
          return _this.toShareWeiXinHY();
        }
      },
      wxpyq: {
        id: "wxpyq",
        channel: ChannelEnum.wxpyq,
        icon: require("./icon/wxpyq-icon.png"),
        text: "朋友圈",
        onHandle: function onHandle() {
          return _this.toShareWeiXinPYQ();
        }
      },
      weibo: {
        id: "weibo",
        channel: ChannelEnum.weibo,
        icon: require("./icon/weibo-icon.png"),
        text: "新浪微博",
        onHandle: function onHandle() {
          return _this.toShareWeiBo();
        }
      },
      qq: {
        id: "qq",
        channel: ChannelEnum.qq,
        icon: require("./icon/qq-icon.png"),
        text: "QQ好友",
        onHandle: function onHandle() {
          return _this.toShareQQ();
        }
      }
    });
    /**
     * @private
     * 分享标题
     */


    _Share_title.set(this, void 0);
    /**
     * @private
     * 分享描述
     */


    _Share_desc.set(this, void 0);
    /**
     * @private
     * 分享链接
     */


    _Share_link.set(this, void 0);
    /**
     * @private
     * 分享图标
     */


    _Share_thumbImangeUrl.set(this, void 0);
    /**
     * 支持分享的平台
     */


    _Share_support.set(this, void 0);
    /**
     * 是否需要开启微信二次分享
     */


    _Share_isTwiceShare.set(this, void 0);
    /**
     * 需要分享的平台
     * @returns
     */


    this.getSupportData = function () {
      return __classPrivateFieldGet(_this, _Share_support, "f").map(function (support) {
        return __classPrivateFieldGet(_this, _Share_supportsConfig, "f")[support];
      });
    }; // 分享到微信好友


    this.toShareWeiXinHY = function (config) {
      if (config) {
        __classPrivateFieldSet(_this, _Share_title, config.title, "f");

        __classPrivateFieldSet(_this, _Share_desc, config.desc, "f");

        __classPrivateFieldSet(_this, _Share_link, config.link || location.href, "f");
      }

      __classPrivateFieldGet(_this, _Share_instances, "m", _Share_nativeShareDirective).call(_this, ChannelEnum.wxhy);
    }; // 分享到微信朋友圈


    this.toShareWeiXinPYQ = function (config) {
      if (config) {
        __classPrivateFieldSet(_this, _Share_title, config.title, "f");

        __classPrivateFieldSet(_this, _Share_desc, config.desc, "f");

        __classPrivateFieldSet(_this, _Share_link, config.link || location.href, "f");
      }

      __classPrivateFieldGet(_this, _Share_instances, "m", _Share_nativeShareDirective).call(_this, ChannelEnum.wxpyq);
    };

    __classPrivateFieldSet(this, _Share_title, params.title, "f");

    __classPrivateFieldSet(this, _Share_desc, params.desc, "f");

    __classPrivateFieldSet(this, _Share_link, params.link || location.href, "f");

    __classPrivateFieldSet(this, _Share_thumbImangeUrl, params.thumbImangeUrl || Share.shareIconStatic, "f");

    __classPrivateFieldSet(this, _Share_support, (_a = params.support) !== null && _a !== void 0 ? _a : Share.supportStatic, "f");

    __classPrivateFieldSet(this, _Share_isTwiceShare, (_b = params.isTwiceShare) !== null && _b !== void 0 ? _b : false, "f");

    __classPrivateFieldGet(this, _Share_instances, "m", _Share_wxShare).call(this);
  }
  /**
   * 更新分享数据
   */


  _createClass(Share, [{
    key: "update",
    value: function update(params) {
      var _a;

      if (!__classPrivateFieldGet(this, _Share_instances, "m", _Share_isEqual).call(this, params)) {
        __classPrivateFieldSet(this, _Share_title, params.title, "f");

        __classPrivateFieldSet(this, _Share_desc, params.desc, "f");

        __classPrivateFieldSet(this, _Share_link, params.link || location.href, "f");

        __classPrivateFieldSet(this, _Share_thumbImangeUrl, params.thumbImangeUrl || Share.shareIconStatic, "f");

        __classPrivateFieldSet(this, _Share_support, (_a = params.support) !== null && _a !== void 0 ? _a : Share.supportStatic, "f");

        __classPrivateFieldGet(this, _Share_instances, "m", _Share_wxShare).call(this);
      }
    } // 分享到微博

  }, {
    key: "toShareWeiBo",
    value: function toShareWeiBo(config) {
      if (config) {
        __classPrivateFieldSet(this, _Share_title, config.title, "f");

        __classPrivateFieldSet(this, _Share_desc, config.desc, "f");

        __classPrivateFieldSet(this, _Share_link, config.link || location.href, "f");
      }

      __classPrivateFieldGet(this, _Share_instances, "m", _Share_nativeShareDirective).call(this, ChannelEnum.weibo);
    } // 分享到QQ好友

  }, {
    key: "toShareQQ",
    value: function toShareQQ(config) {
      if (config) {
        __classPrivateFieldSet(this, _Share_title, config.title, "f");

        __classPrivateFieldSet(this, _Share_desc, config.desc, "f");

        __classPrivateFieldSet(this, _Share_link, config.link || location.href, "f");
      }

      __classPrivateFieldGet(this, _Share_instances, "m", _Share_nativeShareDirective).call(this, ChannelEnum.qq);
    }
  }]);

  return Share;
}();
_Share_supportsConfig = new WeakMap(), _Share_title = new WeakMap(), _Share_desc = new WeakMap(), _Share_link = new WeakMap(), _Share_thumbImangeUrl = new WeakMap(), _Share_support = new WeakMap(), _Share_isTwiceShare = new WeakMap(), _Share_instances = new WeakSet(), _Share_getURL = function _Share_getURL() {
  return new URL(__classPrivateFieldGet(this, _Share_link, "f"));
}, _Share_getShareLink = function _Share_getShareLink() {
  var url = __classPrivateFieldGet(this, _Share_instances, "m", _Share_getURL).call(this);

  url.searchParams.set("recommend", "1"); // 版本号查询参数

  var appversion = getVersion();
  appversion && url.searchParams.set("appversion", appversion);
  return url.href;
}, _Share_nativeShareDirective = function _Share_nativeShareDirective(channel) {
  console.log("\u5206\u4EAB\u5E73\u53F0==>", channel);
  console.log("\u5206\u4EAB\u6807\u9898==>", __classPrivateFieldGet(this, _Share_title, "f"));
  console.log("\u5206\u4EAB\u63CF\u8FF0==>", __classPrivateFieldGet(this, _Share_desc, "f"));
  console.log("分享链接==>", __classPrivateFieldGet(this, _Share_instances, "m", _Share_getShareLink).call(this));
  console.log("分享图标==>", __classPrivateFieldGet(this, _Share_thumbImangeUrl, "f"));
  onRequest("4", {
    channel: String(channel),
    title: __classPrivateFieldGet(this, _Share_title, "f"),
    description: __classPrivateFieldGet(this, _Share_desc, "f"),
    thumbImageUrl: __classPrivateFieldGet(this, _Share_thumbImangeUrl, "f"),
    link: __classPrivateFieldGet(this, _Share_instances, "m", _Share_getShareLink).call(this)
  });
}, _Share_wxShare = function _Share_wxShare() {
  var _a;

  return __awaiter(this, void 0, void 0, /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
    var wxparams, _yield$import, wxInstance;

    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(isFromWeiXin() && __classPrivateFieldGet(this, _Share_isTwiceShare, "f"))) {
              _context.next = 8;
              break;
            }

            wxparams = {
              title: __classPrivateFieldGet(this, _Share_title, "f"),
              desc: __classPrivateFieldGet(this, _Share_desc, "f"),
              imgUrl: __classPrivateFieldGet(this, _Share_thumbImangeUrl, "f"),
              link: __classPrivateFieldGet(this, _Share_link, "f")
            };
            _context.next = 4;
            return import("fastman3-dfyjapp-wxshare");

          case 4:
            _yield$import = _context.sent;
            wxInstance = _yield$import.wxInstance;
            console.log("开启微信二次分享", wxparams);
            (_a = wxInstance === null || wxInstance === void 0 ? void 0 : wxInstance.setWxShareInfo) === null || _a === void 0 ? void 0 : _a.call(wxInstance, wxparams);

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
}, _Share_isEqual = function _Share_isEqual(newp) {
  var newparams = Object.entries(newp);
  var oldparams = Object.entries({
    title: __classPrivateFieldGet(this, _Share_title, "f"),
    desc: __classPrivateFieldGet(this, _Share_desc, "f")
  });
  return JSON.stringify(newparams) === JSON.stringify(oldparams);
};
Share.shareIconStatic = process.env.ASSET_ENV_URL + "/images/public/60.png";
Share.supportStatic = ["wxhy", "wxpyq"];