/*
 * @Author: jiangxin
 * @Date: 2022-05-02 20:29:28
 * @Company: orientsec.com.cn
 * @Description: 小程序分享
 */
import React from "react";
import { View } from "@tarojs/components";
import { useShareAppMessage, useShareTimeline, useRouter } from "@tarojs/taro";
/**
 * 分享组件
 */

export var SharePanel = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var title = props.title,
      link = props.link,
      thumbImangeUrl = props.thumbImangeUrl;

  var _useRouter = useRouter(),
      path = _useRouter.path; // 分享到朋友圈，目前仅支持Android


  useShareTimeline(function () {
    console.log("分享到朋友圈");
    return {
      title: title,
      imageUrl: thumbImangeUrl !== null && thumbImangeUrl !== void 0 ? thumbImangeUrl : process.env.ASSET_ENV_URL + "/images/public/60.png"
    };
  });
  /**
   * 转发微信好友
   */

  useShareAppMessage(function (res) {
    console.log("path", path);
    console.log("转发微信好友");
    return {
      title: title,
      //   imageUrl: thumbImangeUrl,
      path: link !== null && link !== void 0 ? link : path
    };
  });
  return /*#__PURE__*/React.createElement(View, null);
});